%define	name    smalltalk
%define	version	3.1
%define	release	%mkrel 6

Summary:	Smalltalk free language implementation
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPLv2+ and LGPLv2+ and GFDL
Group:		Development/Other
Source0:	ftp://ftp.gnu.org/gnu/smalltalk/%{name}-%{version}.tar.gz
# Don't save image at gst-blox startup, otherwise you get a permission denied
# error (patch from Debian)
Patch1:		smalltalk-3.0.1-blox-startup.patch
# Fix for Tcl 8.6 (interp->result, TIP #330) - AdamW 2008/12
Patch2:		smalltalk-3.1-tcl86.patch
Patch3:		smalltalk-3.0.4-CVE-2009-3736.diff
Patch4:		smalltalk-3.1-gmp-5.0.patch
URL:		http://smalltalk.gnu.org/
BuildRequires:	gtk+2-devel emacs-bin
BuildRequires:	readline-devel termcap-devel
BuildRequires:	tcl tcl-devel tk tk-devel
BuildRequires:	gdbm-devel
BuildRequires:	gmp-devel
BuildRequires:	sqlite3-devel
BuildRequires:	texinfo
BuildRequires:	libpq-devel
BuildRequires:	zlib-devel
BuildRequires:	zip
BuildRequires:	libsigsegv-devel
BuildRequires:	ffi5-devel
BuildRequires:	SDL-devel
BuildRequires:	SDL_mixer-devel
BuildRequires:	SDL_image-devel
BuildRequires:	SDL_sound-devel
BuildRequires:	SDL_ttf-devel
BuildRequires:	mesaglut-devel
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
GNU Smalltalk is a Free (or Open Source) implementation that closely 
follows the Smalltalk-80 language as described in the book Smalltalk-80: 
the Language and its Implementation by Adele Goldberg and David          
Robson. GNUSmalltalk runs on most versions of Unix or Unix like 
systems (GNU/Linux, FreeBSD, etc...).        
There is even a version for commercial operating systems like MS-NT.

%package emacs
Summary:      Smalltalk mode for Emacs
Group:        Development/Other
Requires:     %{name} = %{version}-%{release}
Conflicts:    smalltalk < 3.0.1-1

%description emacs
GNU Smalltalk is a Free (or Open Source) implementation that closely
follows the Smalltalk-80 language as described in the book Smalltalk-80:
the Language and its Implementation by Adele Goldberg and David
Robson. GNUSmalltalk runs on most versions of Unix or Unix like
systems (GNU/Linux, FreeBSD, etc...).
There is even a version for commercial operating systems like MS-NT.

This Package contains the Smalltalk mode for Emacs.

%package devel
Summary:      Development files for GNU Smalltalk
Group:        Development/Other
Requires:     %{name} = %{version}-%{release}
Conflicts:    smalltalk < 3.0.1-2

%description devel
GNU Smalltalk is a Free (or Open Source) implementation that closely
follows the Smalltalk-80 language as described in the book Smalltalk-80:
the Language and its Implementation by Adele Goldberg and David
Robson. GNUSmalltalk runs on most versions of Unix or Unix like
systems (GNU/Linux, FreeBSD, etc...).
There is even a version for commercial operating systems like MS-NT.

This Package contains header files and other stuff provided by
GNU Smalltalk. You will need this package, if you want to extent GNU
Smalltalk with functions written in C.

%prep
%setup -q
%patch1 -p1 -b .blox-startup
%patch2 -p1 -b .tcl86
%patch3 -p1 -b .CVE-2009-3736
%patch4 -p1 -b .gmp

%build
%configure2_5x --disable-static \
           --disable-rpath \
	   --with-tcl=%{_libdir} --with-tk=%{_libdir} \
           --with-system-libsigsegv \
           --with-system-libffi=yes \
           --with-imagedir=%{_libdir}/%{name}
%make

cd doc
for i in gst*;
do
  sed -i -e 's!%{_libdir}!/usr/lib(64)!g' \
         -e 's!/usr/lib!/usr/lib(64)!g' \
         -e 's!/usr/share/smalltalk/kernel!/usr/lib(64)/smalltalk/kernel!g' $i
done

%install
rm -fr %buildroot
%{makeinstall_std}

%multiarch_binaries $RPM_BUILD_ROOT%{_bindir}/gst-config

%clean
rm -fr %buildroot

%post
%_install_info gst.info

%preun
%_remove_install_info gst.info

%files 
%defattr(-,root,root)
%doc AUTHORS NEWS README
%{_bindir}/gst
%{_bindir}/gst-blox
%{_bindir}/gst-convert
%{_bindir}/gst-doc
%{_bindir}/gst-load
%{_bindir}/gst-package
%{_bindir}/gst-reload
%{_bindir}/gst-remote
%{_bindir}/gst-sunit
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/*
%{_libdir}/*.so.*
%{_libdir}/smalltalk
%{_infodir}/*.info*
%{_mandir}/man1/*

%files devel                                                                                                                                                    
%defattr(-,root,root)
%{_bindir}/gst-config
%multiarch %{multiarch_bindir}/gst-config
%{_libdir}/libgst.so
%{_libdir}/pkgconfig/gnu-smalltalk.pc
%{_datadir}/aclocal/*.m4
%{_includedir}/gst.h
%{_includedir}/gstpub.h
%{_libdir}/*.la

%files emacs
%defattr(-,root,root)
%{_datadir}/emacs/site-lisp/*


%changelog
* Wed Feb 10 2010 Funda Wang <fwang@mandriva.org> 3.1-6mdv2010.1
+ Revision: 503834
- add upstream patch to build with gmp 5.0
- rebuild for new gmp

* Mon Nov 30 2009 Oden Eriksson <oeriksson@mandriva.com> 3.1-5mdv2010.1
+ Revision: 471771
- P3: security fix for CVE-2009-3736

* Sun Aug 09 2009 Frederik Himpe <fhimpe@mandriva.org> 3.1-4mdv2010.0
+ Revision: 412948
- Rebuild against new libsigsegv2

* Fri Apr 03 2009 Funda Wang <fwang@mandriva.org> 3.1-3mdv2009.1
+ Revision: 363763
- clean spec

* Sat Dec 06 2008 Adam Williamson <awilliamson@mandriva.org> 3.1-2mdv2009.1
+ Revision: 311080
- rebuild for new tcl
- add tcl86.patch (fix build for Tcl 8.6)

* Tue Nov 11 2008 Frederik Himpe <fhimpe@mandriva.org> 3.1-1mdv2009.1
+ Revision: 302219
- Update to new version 3.1
- Build against libffi5 instead of libffi4
- Add mesaglut and sdl buildrequirements for building the new bindings
- Disable rpath
- Fix paths in documentation

* Wed Aug 13 2008 Frederik Himpe <fhimpe@mandriva.org> 3.0.4-1mdv2009.0
+ Revision: 271502
- update to new version 3.0.4

* Thu Aug 07 2008 Thierry Vignaud <tvignaud@mandriva.com> 3.0.3-2mdv2009.0
+ Revision: 265706
- rebuild early 2009.0 package (before pixel changes)

* Thu May 22 2008 Frederik Himpe <fhimpe@mandriva.org> 3.0.3-1mdv2009.0
+ Revision: 210121
- New version
- Remove sigsegv.patch: it was integrated upstream
- add configure options to build against system libs
- Fix summary for devel package

  + Thierry Vignaud <tvignaud@mandriva.com>
    - fix description-line-too-long

* Sat Feb 09 2008 Frederik Himpe <fhimpe@mandriva.org> 3.0.1-2mdv2008.1
+ Revision: 164476
- Split out smalltalk-devel package
- Build against system libsigsegv, to fix the conflict with libsigsegv
- Fix BuildRequires
- Don't save the image at gst-blox start-up, to fix a permission denied
  error

* Wed Feb 06 2008 Frederik Himpe <fhimpe@mandriva.org> 3.0.1-1mdv2008.1
+ Revision: 163239
- New upstream version
- Fix buildrequires
- Put Smalltalk mode for Emacs in a separate subpackage
- Adapt to license policy

* Wed Jan 02 2008 Thierry Vignaud <tvignaud@mandriva.com> 2.3.3-3mdv2008.1
+ Revision: 140770
- fix source name
- kill re-definition of %%buildroot on Pixel's request

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Gustavo De Nardin <gustavodn@mandriva.com>
    - dropped patch for PaX, useless for kernel 2.6, as found out by Frederik Himpe months ago (<http://marc.info/?l=mandrake-cooker&m=117088575205216&w=2>, <http://lists.gnu.org/archive/html/help-smalltalk/2007-02/msg00004.html>)
    - package URL fixed to point to GNU Smalltalk site


* Tue Mar 06 2007 Emmanuel Andry <eandry@mandriva.org> 2.3.3-3mdv2007.0
+ Revision: 133447
- New version 2.3.3
- drop patch0
- uncompress patch
- Import smalltalk

* Mon Jun 19 2006 Stefan van der Eijk <stefan@eijk.nu> 2.1.12-3
- rebuild for png
- %%mkrel

* Tue Jan 03 2006 Oden Eriksson <oeriksson@mandriva.com> 2.1.12-2mdk
- rebuilt against soname aware deps (tcl/tk)
- fix deps

* Sun Dec 04 2005 Pascal Terjan <pterjan@mandriva.org> 2.1.12-1mdk
- 2.1.12

* Sun Jul 24 2005 Pascal Terjan <pterjan@mandriva.org> 2.1.11-1mdk
- 2.1.11
- stole 2 patches from PLD but their amd64 patch does not fix the loop at the
  end of x86_64 build

* Thu Feb 03 2005 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 2.1.10-1mdk
- 2.1.10

* Wed Feb 02 2005 Daouda LO <daouda@mandrakesoft.com> 2.1.9-3mdk
- multiarch

* Thu Jan 20 2005 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 2.1.9-2mdk
- rebuild for new readline

* Tue Nov 16 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 2.1.9-1mdk
- 2.1.9
- updated license (as libraries are licensed under LGPL)

